unit MainSampleUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ExtCtrls, ExtDlgs, ComCtrls, ActnList, XPStyleActnCtrls,
  ActnMan, ToolWin, ActnCtrls, ActnMenus, StdStyleActnCtrls;

type
  TMainForm = class(TForm)
    ActionMainMenuBar: TActionMainMenuBar;
    ActionManager: TActionManager;
    Action_OpenPicture: TAction;
    Action_Exit: TAction;
    StatusBar: TStatusBar;
    OpenPictureDialog: TOpenPictureDialog;
    PaintBox: TPaintBox;
    ScrollBox: TScrollBox;
    MenuImageList: TImageList;
    Action_OpenClipBoard: TAction;
    Action_Eff_Mirror: TAction;
    Action_Eff_R90: TAction;
    Action_Eff_L90: TAction;
    ActionToolBar1: TActionToolBar;
    Action_Eff_Nega: TAction;
    Action_Eff_Mono: TAction;
    procedure Action_Eff_MonoExecute(Sender: TObject);
    procedure Action_Eff_NegaExecute(Sender: TObject);
    procedure Action_Eff_L90Execute(Sender: TObject);
    procedure Action_Eff_R90Execute(Sender: TObject);
    procedure Action_Eff_MirrorExecute(Sender: TObject);
    procedure Action_OpenClipBoardExecute(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure Action_OpenPictureExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Action_ExitExecute(Sender: TObject);
  private
    { Private 錾 }

    BackBMP:TBitmap;

    procedure PaintTo;



  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

uses jpeg,ClipBrd,buinPicFilters;

{$R *.dfm}

procedure TMainForm.PaintTo;
begin

    PaintBox.Width :=BackBMP.Width;
    PaintBox.Height:=BackBMP.Height;
    PaintBox.OnPaint(nil);
    
end;

procedure TMainForm.Action_ExitExecute(Sender: TObject);
begin
 //I
 Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin

  BackBMP:=TBitmap.Create;


end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  BackBMP.Free;
end;

procedure TMainForm.Action_OpenPictureExecute(Sender: TObject);

 procedure LoadPicture(FileName:String);
 var s:String;
     jpeg:TJpegImage;
 begin

    s:=AnsiLowerCase(ExtractFileExt(FileName));

    if s='.bmp' then begin
       BackBMP.LoadFromFile(Filename);

    end else if (s='.jpg') or (s='.jpeg') then begin
       jpeg:=TJPEGImage.Create;
       try 
         jpeg.LoadFromFile(FileName);
         backBMP.Assign(jpeg);
       finally
         jpeg.Free;
       end;

    end else begin
       ShowMessage('̃t@C͓ǂݍ݂ł܂');
    end;

    //摜XV
    PaintTo;

 end;

begin
 //摜I[v

 if OpenPictureDialog.Execute then begin
    LoadPicture(OpenPictureDialog.FileName);


 end;

end;

procedure TMainForm.PaintBoxPaint(Sender: TObject);
begin

  //ʂ֓]
  BitBlt(PaintBox.Canvas.Handle,0,0,BackBMP.Width,BackBMP.Height,BackBMP.Canvas.Handle,0,0,SRCCOPY);

end;

procedure TMainForm.Action_OpenClipBoardExecute(Sender: TObject);
begin

   //Nbv{[hJ
   if Clipboard.HasFormat(CF_BITMAP) then begin
      BackBMP.Assign(Clipboard);
      //摜XV
      PaintTo;
   end;


end;

procedure TMainForm.Action_Eff_MirrorExecute(Sender: TObject);
var Filter:TBuinPicFilters;
begin

  Filter:=TBuinPicFilters.Create;
  try
    //~[]
    Filter.RotateMirror(BackBMP);
    //摜XV
    PaintTo;

  finally
    Filter.Free;
  end;

end;

procedure TMainForm.Action_Eff_R90Execute(Sender: TObject);
var Filter:TBuinPicFilters;
begin

  Filter:=TBuinPicFilters.Create;
  try
    //~[]
    Filter.Rotate90Right(BackBMP);
    //摜XV
    PaintTo;

  finally
    Filter.Free;
  end;
  
end;

procedure TMainForm.Action_Eff_L90Execute(Sender: TObject);
var Filter:TBuinPicFilters;
begin

  Filter:=TBuinPicFilters.Create;
  try
    //~[]
    Filter.Rotate90Left(BackBMP);
    //摜XV
    PaintTo;

  finally
    Filter.Free;
  end;

end;

procedure TMainForm.Action_Eff_NegaExecute(Sender: TObject);
var Filter:TBuinPicFilters;
begin

  Filter:=TBuinPicFilters.Create;
  try
    //~[]
    Filter.Nega(BackBMP);
    //摜XV
    PaintTo;

  finally
    Filter.Free;
  end;

end;

procedure TMainForm.Action_Eff_MonoExecute(Sender: TObject);
var Filter:TBuinPicFilters;
begin

  Filter:=TBuinPicFilters.Create;
  try
    //~[]
    Filter.Monochrome(BackBMP);
    //摜XV
    PaintTo;

  finally
    Filter.Free;
  end;

end;
end.
