//////////////////////////////////////////////////////////////////////////////////////////
//  
//  buinPictureFilters for 32bit and 24 bit Bitmaps
//  Copyright(C)'2004- buin2gou / Buin2gouLaboratories,Inc.
//  
//  ̃Cu̓t[EFAłBp̍ۂ̃CeBEgp͖łB
//  

unit buinPicFilters;

interface

uses windows,classes,graphics,SysUtils;

type
  PDWordArray = ^TDWordArray;
  TDWordArray = array[0..8191] of DWord;

type
  TRGBA=packed record
       r:Byte;
       g:Byte;
       b:Byte;
       a:Byte;
  end;
  TRGBAArray = array[0..8191] of TRGBA;
  PRGBAArray = ^TRGBAArray;

type
  TRGB=packed record
       r:Byte;
       g:Byte;
       b:Byte;
  end;
  TRGBArray = array[0..8191] of TRGB;
  PRGBArray = ^TRGBArray;



  type TBuinBusyEvent=procedure(iPosition:Integer;iAll:Integer) of object;


  type TBuinPicFilters=class

       //Cxg
       FOnProgress:TBuinBusyEvent;


       {tB^[֌W}
       //
       function Monochrome(BMP:TBitmap):Boolean;
       //ZsA
       function Sepia(BMP:TBitmap;Color:TColor):Boolean;
       //UCN
       function Mosaic(BMP:TBitmap;iW,iH:Integer):Boolean;
       //FύX
       function ColorRevison(BMP:TBitmap;r,g,b:Integer):Boolean;
       //lK]
       function Nega(BMP:TBitmap):Boolean;
       //邳
       function Bright(BMP:TBitmap;iPower:SmallInt):Boolean;
       //RgXg
       function Contrast(BMP:TBitmap;iPower:Integer):Boolean;
       //ڂ
       function Blur(BMP:TBitmap;iPower:SmallInt):Boolean;
       //\[[V
       function Solarization(BMP:TBitmap;iCh:Byte;iPower:Integer):Boolean;
       //|X^[[V
       function Postlarization(BMP:TBitmap;iCh,iPower:Integer):Boolean;
       //`l
       function ChannelExchange(BMP:TBitmap;iIn,iOut:Byte;bNot,bTrade:Boolean):Boolean;


       {ό`֌W}
       function  RotateMirror(BMP:TBitmap):Boolean;
       function  RotateTopBottom(BMP:TBitmap):Boolean;

       {]֌W}
       function  Rotate90Right(BMP:TBitmap):Boolean;
       function  Rotate90Left(BMP:TBitmap):Boolean;

       {AtBϊ}
       function  Affine(a,b,c,d,e,f:Integer;BMP,NewBMP:TBitmap):Boolean;

       {Cxg}
       property OnProgress:TBuinBusyEvent read FOnProgress write FOnProgress;

  end;

  {NXO֐}
  function RoundByte(data:Integer):Byte;


implementation

/////////////////////////////////////////////////////////
//
//   
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Monochrome(BMP:TBitmap):Boolean;

   procedure Mono24(BMP:TBitmap);
   var x,y:Integer;
       pBit:PByteArray;
       i:Integer;
       res:Integer;
   begin
      for y:=0 to BMP.Height-1 do begin
          pBit:=BMP.Scanline[y];

          //CfbNX
          i:=0;

          for x:=0 to BMP.Width-1 do begin
              //YUV䗦AmNlvZ
              res:=(pBit[i]*77+pBit[i+1]*150+pBit[i+2]*29) shr 8;
              //o
              pBit[i]:=res;inc(i);
              pBit[i]:=res;inc(i);
              pBit[i]:=res;inc(i);
          end;

          //R[obN
          if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
   end;

   procedure Mono32(BMP:TBitmap);
   var x,y:Integer;
       pBit:PByteArray;
       i:Integer;
       res:Integer;
   begin
      for y:=0 to BMP.Height-1 do begin
          pBit:=BMP.Scanline[y];

          //CfbNX
          i:=0;

          for x:=0 to BMP.Width-1 do begin
              //YUV䗦AmNlvZ
              res:=(pBit[i]*77+pBit[i+1]*150+pBit[i+2]*29) shr 8;
              //o
              pBit[i]:=res;inc(i);
              pBit[i]:=res;inc(i);
              pBit[i]:=res;inc(i,2);
          end;

          //R[obN
          if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
   end;

begin

  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Mono32(BMP);
       pf24bit:Mono24(BMP);
       else begin
        Result:=False;
       end;
  end;
  
end;

/////////////////////////////////////////////////////////
//
//   ZsA
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Sepia(BMP:TBitmap;Color:TColor):Boolean;
var iR,iG,iB:WORD;

   procedure MakeTable(var RTable,GTable,BTable:array of Byte;r,g,b:Byte);
   var a,i:Integer;
   begin
     { ϊe[u쐬 }
     for I := 0 to 127 do begin
         RTable[I]:=((i*r) shr 7);
         GTable[I]:=((i*g) shr 7);
         BTable[I]:=((i*b) shr 7);
         a:=127-i;
         RTable[I+128]:=((a*r)+(i*255)) shr 7;
         GTable[I+128]:=((a*g)+(i*255)) shr 7;
         BTable[I+128]:=((a*b)+(i*255)) shr 7;
     end;
   end;

   procedure Sepia32(Bitmap: TBitmap;r,g,b:Byte);
   var
     X,Y,I:Integer;
     RTable,GTable,BTable:array[0..255] of Byte;
     pbit:PByteArray;
     a:Integer;
   begin

     MakeTable(RTable,GTable,BTable,r,g,b);

     { sNZϊ }
     for Y:=0 to Bitmap.Height-1 do begin
         pbit:=Bitmap.ScanLine[Y];
         i:=0;
         for X:=0 to Bitmap.Width-1 do begin
             //ϊ
             a:=(pBit[i]*77+pBit[i+1]*150+pBit[i+2]*29) shr 8;
             //Fϊe[uu
             pBit[i]:=BTable[a];inc(i);
             pBit[i]:=GTable[a];inc(i);
             pBit[i]:=RTable[a];inc(i,2);
         end;
         //R[obN
         if @OnProgress<>nil then OnProgress(y,BMP.Height);
     end;
   end;

   procedure Sepia24(Bitmap: TBitmap;r,g,b:Byte);
   var
     X,Y,I:Integer;
     RTable,GTable,BTable:array[0..255] of Byte;
     pbit:PByteArray;
     a:Integer;
   begin

     MakeTable(RTable,GTable,BTable,r,g,b);

     { sNZϊ }
     for Y:=0 to Bitmap.Height-1 do begin
         pbit:=Bitmap.ScanLine[Y];
         i:=0;
         for X:=0 to Bitmap.Width-1 do begin
             //ϊ
             a:=(pBit[i]*77+pBit[i+1]*150+pBit[i+2]*29) shr 8;
             //Fϊe[uu
             pBit[i]:=BTable[a];inc(i);
             pBit[i]:=GTable[a];inc(i);
             pBit[i]:=RTable[a];inc(i);
         end;
         //R[obN
         if @OnProgress<>nil then OnProgress(y,BMP.Height);
     end;
   end;


begin

  //
  Result:=True;

  //Fϊ
  iB:=(Color and $000000FF);
  iG:=(Color and $0000FF00) shr 8;
  iR:=(Color and $00FF0000) shr 16;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Sepia32(BMP,iR,iG,iB);
       pf24bit:Sepia24(BMP,iR,iG,iB);
       else begin
        Result:=False;
       end;
  end;
  
end;


/////////////////////////////////////////////////////////
//
//   UCN
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Mosaic(BMP:TBitmap;iW,iH:Integer):Boolean;

    procedure Mosaic32(mw,mh:Integer;BMP:TBitmap);
    var x,y:Integer;
        pBit,pBit2:PDWORDArray;
        //p
        bufX:PDWORDArray;
    begin
       GetMEM(bufX,(BMP.Width+1)*SizeOf(DWord));

       for x:=0 to BMP.Width-1 do begin
           bufX[x]:=(x div mw)*mw;
       end;

       for y:=0 to BMP.Height-1 do begin
           ///݂͉̓摜̍ʒu
           pBit :=BMP.ScanLine[y];
           pBit2:=BMP.ScanLine[(y div mh)*mw];
           for x:=0 to BMP.Width-1 do begin
               pBit[x]:=pBit2[bufX[x]];
           end;
          //R[obN
          if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;
       FreeMEM(bufX);
    end;
    
    procedure Mosaic24(mw,mh:Integer;BMP:TBitmap);
    var x,y:Integer;
        pBit,pBit2:PRGBArray;
        //p
        bufX:PDWORDArray;
    begin
       GetMEM(bufX,(BMP.Width+1)*SizeOf(DWord));

       for x:=0 to BMP.Width-1 do begin
           bufX[x]:=(x div mw)*mw;
       end;

       for y:=0 to BMP.Height-1 do begin
           ///݂͉̓摜̍ʒu
           pBit :=BMP.ScanLine[y];
           pBit2:=BMP.ScanLine[(y div mh)*mw];
           for x:=0 to BMP.Width-1 do begin
               pBit[x]:=pBit2[bufX[x]];
           end;
          //R[obN
          if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;
       FreeMEM(bufX);
    end;

begin

  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Mosaic32(iW,iH,BMP);
       pf24bit:Mosaic24(iW,iH,BMP);
       else begin
        Result:=False;
       end;
  end;
  
end;

/////////////////////////////////////////////////////////
//
//   邳
//
/////////////////////////////////////////////////////////
function TBuinPicFilters.Bright(BMP:TBitmap;iPower:SmallInt):Boolean;

   procedure Bright32(BMP:TBitmap;iPower:SmallInt);
   var
    x,y  :SmallInt;  //rbg}bv̂wAx
    pBit:PRGBAArray;
    rgba:TRGBA;
   begin
    //邳
    for y:=0 to BMP.Height-1 do begin
       pBit:=BMP.ScanLine[y];
       for x:=0 to BMP.Width-1 do begin
           rgba:=pBit[x];
           rgba.r:=RoundByte(rgba.r+iPower);
           rgba.g:=RoundByte(rgba.g+iPower);
           rgba.b:=RoundByte(rgba.b+iPower);
           pBit[x]:=rgba;
       end;
       //R[obN
       if @OnProgress<>nil then OnProgress(y,BMP.Height);
    end;
   end;

   procedure Bright24(BMP:TBitmap;iPower:SmallInt);
   var
    x,y  :SmallInt;  //rbg}bv̂wAx
    pBit:PRGBArray;
    rgb:TRGB;
   begin
    //邳
    for y:=0 to BMP.Height-1 do begin
       pBit:=BMP.ScanLine[y];
       for x:=0 to BMP.Width-1 do begin
           rgb:=pBit[x];
           rgb.r:=RoundByte(rgb.r+iPower);
           rgb.g:=RoundByte(rgb.g+iPower);
           rgb.b:=RoundByte(rgb.b+iPower);
           pBit[x]:=rgb;
       end;
       //R[obN
       if @OnProgress<>nil then OnProgress(y,BMP.Height);
    end;
   end;
   
begin
   
   //
   Result:=True;

   //ۂ̏
   case BMP.PixelFormat of
        pf32bit:Bright32(BMP,iPower);
        pf24bit:Bright24(BMP,iPower);
        else begin
         Result:=False;
        end;
   end;
  
end;

/////////////////////////////////////////////////////////
//
//   ڂ
//
/////////////////////////////////////////////////////////
function TBuinPicFilters.Blur(BMP:TBitmap;iPower:SmallInt):Boolean;

    procedure Blur32(BMP:TBitmap;Power:Integer);
    var
      x,y,i,j,k,m,l:SmallInt;  //rbg}bv̂wAx
      R,G,B,A   :WORD;      //qlAflAal
      PBit,PBit2:PRGBAArray;
      RGBA      :TRGBA;
      W,H,x2,y2 :Integer;
      k1,k2,k3  :Integer;
      SrcLine   :array of Pointer;
    begin
      //FX
      H:=BMP.Height-1;
      W:=BMP.Width-1;

      SetLength(SrcLine,BMP.Height);
      for y:=0 to BMP.Height-1 do begin
          SrcLine[y]:=BMP.ScanLine[y];
      end;

      k3:=-Power;
      //RgXg
      for y := 0 to H do begin
        pBit:=SrcLine[y];
        k:=0;
        k2:=k3;
        for x := 0 to W do begin
           //
           r:=0;g:=0;b:=0;
           a:=0;m:=0;
           k1:=k2;
           inc(k2);
           //qfaf[^擾
           for y2:=-Power to Power do begin
               j:=y+y2;
               If j>=H then break;
               If (j>=0) then begin
                  PBit2:=SrcLine[j];
                  i:=k1;
                  for x2:=-Power to Power do begin
                      If i>=W then break;
                      If (i>=0) then begin
                         //ǂݍ
                         rgba:=PBit2[i];
                         inc(i);
                         //Z
                         r:=r+rgba.r;
                         g:=g+rgba.g;
                         b:=b+rgba.b;
                         a:=a+rgba.a;
                         //Zp
                         inc(m);
                      end else begin
                         inc(i);
                      end;
                   end;
               end;
           end;
          rgba.r:=r div m;
          rgba.g:=g div m;
          rgba.b:=b div m;
          rgba.a:=a div m;
          //
          pBit[k]:=RGBA;
          inc(k);
        end;
        //R[obN
        if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
    end;

    procedure Blur24(BMP:TBitmap;Power:Integer);
    var
      x,y,i,j,k,m,l:SmallInt;  //rbg}bv̂wAx
      R,G,B     :WORD;      //qlAflAal
      PBit,PBit2:PRGBArray;
      RGB       :TRGB;
      W,H,x2,y2 :Integer;
      k1,k2,k3  :Integer;
      SrcLine   :array of Pointer;
    begin

      //FX

      H:=BMP.Height-1;
      W:=BMP.Width-1;

      SetLength(SrcLine,BMP.Height);
      for y:=0 to BMP.Height-1 do begin
          SrcLine[y]:=BMP.ScanLine[y];
      end;

      k3:=-Power;
      //RgXg
      for y := 0 to H do begin
        pBit:=SrcLine[y];
        k:=0;
        k2:=k3;
        for x := 0 to W do begin
           //
           r:=0;
           g:=0;
           b:=0;
           m:=0;
           k1:=k2;
           inc(k2);
           //qfaf[^擾
           for y2:=-Power to Power do begin
               j:=y+y2;
               If j>=H then break;
               If (j>=0) then begin
                  PBit2:=SrcLine[j];
                  i:=k1;
                  for x2:=-Power to Power do begin
                      If i>=W then break;
                      If (i>=0) then begin
                         //ǂݍ
                         rgb:=PBit2[i];
                         //Z
                         r:=r+rgb.r;
                         g:=g+rgb.g;
                         b:=b+rgb.b;
                         //Zp
                         inc(m);inc(i);
                      end else begin
                         inc(i);
                      end;
                   end;
               end;
           end;
          rgb.r:=r div m;
          rgb.g:=g div m;
          rgb.b:=b div m;
          //
          pBit[k]:=RGB;
          inc(k);
        end;
        //R[obN
        if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
    end;
    
begin

   if iPower<=0 then begin
      Result:=False;
      exit;
   end;

   //
   Result:=True;

   //ۂ̏
   case BMP.PixelFormat of
        pf32bit:Blur32(BMP,iPower);
        pf24bit:Blur24(BMP,iPower);
        else begin
         Result:=False;
        end;
   end;
  
end;
/////////////////////////////////////////////////////////
//
//   FύX
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.ColorRevison(BMP:TBitmap;r,g,b:Integer):Boolean;
var iR,iG,iB:WORD;

  procedure ColorRevision32(R1,G1,B1:Integer;BMP:TBitmap);
  var
    x,y,i:Integer;  //rbg}bv̂wAx
    pBit :pByteArray;
  begin
    //F␳
    for y := 0 to BMP.Height-1 do begin
        pBit:=BMP.ScanLine[y];
        i:=0;
        for x := 0 to BMP.Width-1 do begin
            pBit[i]:=RoundByte(pBit[i]+b1);inc(i);
            pBit[i]:=RoundByte(pBit[i]+g1);inc(i);
            pBit[i]:=RoundByte(pBit[i]+r1);inc(i,2);
       end;
       //R[obN
       if @OnProgress<>nil then OnProgress(y,BMP.Height);
    end;
  end;
  
  procedure ColorRevision24(R1,G1,B1:Integer;BMP:TBitmap);
  var
    x,y,i:Integer;  //rbg}bv̂wAx
    pBit :pByteArray;
  begin
    //F␳
    for y := 0 to BMP.Height-1 do begin
        pBit:=BMP.ScanLine[y];
        i:=0;
        for x := 0 to BMP.Width-1 do begin
            pBit[i]:=RoundByte(pBit[i]+b1);inc(i);
            pBit[i]:=RoundByte(pBit[i]+g1);inc(i);
            pBit[i]:=RoundByte(pBit[i]+r1);inc(i);
       end;
       //R[obN
       if @OnProgress<>nil then OnProgress(y,BMP.Height);
    end;
  end;

begin
   
  //
  Result:=True;


  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:ColorRevision32(R,G,B,BMP);
       pf24bit:ColorRevision24(R,G,B,BMP);
       else begin
        Result:=False;
       end;
  end;
  
end;

/////////////////////////////////////////////////////////
//
//   F]
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Nega(BMP:TBitmap):Boolean;

   procedure Nega32(BMP:TBitmap);
   var
     x,y:Integer;  //rbg}bv̂wAx
     pBit:PRGBAArray;
     rgba:TRGBA;
   begin
     //@lK|W
     for y:=0 to BMP.Height-1 do begin
         pBit:=BMP.ScanLine[y];
         for x:=0 to BMP.Width-1 do begin
             rgba:=pBit[x];
             rgba.r:=$FF-rgba.r;
             rgba.g:=$FF-rgba.g;
             rgba.b:=$FF-rgba.b;
             pBit[x]:=rgba;
             //`lȊO]B
         end;
         //R[obN
         if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
   end;
   
   procedure Nega24(BMP:TBitmap);
   var
     x,y:Integer;  //rbg}bv̂wAx
     pBit:PRGBArray;
     rgb:TRGB;
   begin
     //@lK|W
     for y:=0 to BMP.Height-1 do begin
         pBit:=BMP.ScanLine[y];
         for x:=0 to BMP.WIdth-1 do begin
             rgb:=pBit[x];
             rgb.r:=$FF-rgb.r;
             rgb.g:=$FF-rgb.g;
             rgb.b:=$FF-rgb.b;
             pBit[x]:=rgb;
             //`lȊO]B
         end;
         //R[obN
         if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
   end;

begin
    
  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Nega32(BMP);
       pf24bit:Nega24(BMP);
       else begin
        Result:=False;
       end;
  end;
  
end;

/////////////////////////////////////////////////////////
//
//   RgXg
//
/////////////////////////////////////////////////////////
function TBuinPicFilters.Contrast(BMP:TBitmap;iPower:Integer):Boolean;

   function Round2Byte(rData:Double):byte;
   begin
     Result:=ROundByte(Round(rData)); 
   end;

   procedure Contrast32(BMP:TBitmap;iPower:Integer);
   var
     x,y :Integer;
     PBit:PRGBAArray;
     rgba:TRGBA;
     rPower:Double;
   begin
     //_vZ
     rPower:=iPower / 255;
     //RgXg
     for y := 0 to BMP.Height-1 do begin
       pBit:=BMP.ScanLine[y];
       for x := 0 to BMP.Width-1 do begin
           rgba:=pBit[x];
           rgba.r:=Round2Byte(rgba.r+rPower*(rgba.r-127.5));
           rgba.g:=Round2Byte(rgba.g+rPower*(rgba.g-127.5));
           rgba.b:=Round2Byte(rgba.b+rPower*(rgba.b-127.5));
           pBit[x]:=rgba;
       end;
       //R[obN
       if @OnProgress<>nil then OnProgress(y,BMP.Height);
     end;
   end;
   
   procedure Contrast24(BMP:TBitmap;iPower:Integer);
   var
     x,y :Integer;
     PBit:PRGBArray;
     rgb :TRGB;
     rPower:Double;
   begin
     //_vZ
     rPower:=iPower / 255;
     //RgXg
     for y := 0 to BMP.Height-1 do begin
       pBit:=BMP.ScanLine[y];
       for x := 0 to BMP.Width-1 do begin
           rgb:=pBit[x];
           rgb.r:=Round2Byte(rgb.r+rPower*(rgb.r-127.5));
           rgb.g:=Round2Byte(rgb.g+rPower*(rgb.g-127.5));
           rgb.b:=Round2Byte(rgb.b+rPower*(rgb.b-127.5));
           pBit[x]:=rgb;
       end;
       //R[obN
       if @OnProgress<>nil then OnProgress(y,BMP.Height);
     end;
   end;
begin
    
  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Contrast32(BMP,iPower);
       pf24bit:Contrast24(BMP,iPower);
       else begin
        Result:=False;
       end;
  end;
  
end;


/////////////////////////////////////////////////////////
//
//   \[[V
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Solarization(BMP:TBitmap;iCh:Byte;iPower:Integer):Boolean;

    procedure Solarization32(Bitmap: TBitmap;iCh:Byte;iPower:Integer);
    var
      X, Y,w: Integer;
      pLine: PByteArray;
      Table: array[0..255]of Byte;
      iCounter:Integer;
    begin
      
      { ϊe[u𐶐 }
      for X := 0 to 255 do begin
          Y := 255-X;
          if X <iPower then Y := X;
          Table[X] := Y;
      end;


      w:=Bitmap.Width -1;

      { sNZ̕ϊ }
      for Y := 0 to Bitmap.Height -1 do begin
        pLine := Bitmap.ScanLine[Y];
        
        //JE^[
        iCounter:=0;
        
        for X := 0 to w do begin
            { قǍϊe[ugp }
            case iCh of
                 0:begin
                   //RGB
                   pLine[iCounter]  :=Table[pLine[iCounter]];
                   pLine[iCounter+1]:=Table[pLine[iCounter+1]];
                   pLine[iCounter+2]:=Table[pLine[iCounter+2]];
                   end;
                 1:begin
                   //R
                   pLine[iCounter]:=Table[pLine[iCounter]];
                   end;
                 2:begin
                   //G
                   pLine[iCounter+1]:=Table[pLine[iCounter+1]];
                   end;
                 3:begin
                   //B
                   pLine[iCounter+2]:=Table[pLine[iCounter+2]];
                   end;
            end;
            inc(iCounter,4);
        end;
        //R[obN
        if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
    end;
    
    procedure Solarization24(Bitmap: TBitmap;iCh:Byte;iPower:Integer);
    // \[[V
    var
      X, Y,w: Integer;
      pLine: PByteArray;
      Table: array[0..255]of Byte;
      iCounter:Integer;
    begin
      
      { ϊe[u𐶐 }
      for X := 0 to 255 do begin
          Y := 255-X;
          if X <iPower then Y := X;
          Table[X] := Y;
      end;


      w:=Bitmap.Width -1;

      { sNZ̕ϊ }
      for Y := 0 to Bitmap.Height -1 do begin
        pLine := Bitmap.ScanLine[Y];
        
        //JE^[
        iCounter:=0;
        
        for X := 0 to w do begin
            { قǍϊe[ugp }
            case iCh of
                 0:begin
                   //RGB
                   pLine[iCounter]  :=Table[pLine[iCounter]];
                   pLine[iCounter+1]:=Table[pLine[iCounter+1]];
                   pLine[iCounter+2]:=Table[pLine[iCounter+2]];
                   end;
                 1:begin
                   //R
                   pLine[iCounter]:=Table[pLine[iCounter]];
                   end;
                 2:begin
                   //G
                   pLine[iCounter+1]:=Table[pLine[iCounter+1]];
                   end;
                 3:begin
                   //B
                   pLine[iCounter+2]:=Table[pLine[iCounter+2]];
                   end;
            end;
            inc(iCounter,3);
        end;
        //R[obN
        if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
    end;
begin

  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Solarization32(BMP,iCh,iPower);
       pf24bit:Solarization24(BMP,iCh,iPower);
       else begin
        Result:=False;
       end;
  end;

end;

/////////////////////////////////////////////////////////
//
//   |X^[[V
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Postlarization(BMP:TBitmap;iCh,iPower:Integer):Boolean;

     procedure Postlarization24(BMP:TBitmap;iCh,iPower:Integer);
     var
       x,y,w:Integer;  //rbg}bv̂wAx
       b    :Integer;
       PBit :PByteArray;
       table:array[0..255] of byte;
       iCounter:Integer;
     begin
       //ʎq

       b:=256 div iPower;
       //e[uč܂B
       for y:=0 to 255 do begin
           table[y]:=RoundByte(Trunc(y / b)*b);
       end;

       //RgXg
       for y := 0 to BMP.Height-1 do begin
           pBit:=BMP.ScanLine[y];
           //JE^[
           iCounter:=0;

          for X := 0 to BMP.Width-1 do begin
              { قǍϊe[ugp }
              case iCh of
                 0:begin
                   //RGB
                   pBit[iCounter]  :=Table[pBit[iCounter]];
                   pBit[iCounter+1]:=Table[pBit[iCounter+1]];
                   pBit[iCounter+2]:=Table[pBit[iCounter+2]];
                   end;
                 1:begin
                   //R
                   pBit[iCounter]:=Table[pBit[iCounter]];
                   end;
                 2:begin
                   //G
                   pBit[iCounter+1]:=Table[pBit[iCounter+1]];
                   end;
                 3:begin
                   //B
                   pBit[iCounter+2]:=Table[pBit[iCounter+2]];
                   end;
              end;
              inc(iCounter,3);
         end;
       end;
     end;

     procedure Postlarization32(BMP:TBitmap;iCh,iPower:Integer);
     var
       x,y,w:Integer;  //rbg}bv̂wAx
       b    :Integer;
       PBit :PByteArray;
       table:array[0..255] of byte;
       iCounter:Integer;
     begin
       //ʎq

       b:=256 div iPower;
       //e[uč܂B
       for y:=0 to 255 do begin
           table[y]:=RoundByte(Trunc(y / b)*b);
       end;

       //RgXg
       for y := 0 to BMP.Height-1 do begin
           pBit:=BMP.ScanLine[y];
           //JE^[
           iCounter:=0;

          for X := 0 to BMP.Width-1 do begin
             { قǍϊe[ugp }
             case iCh of
                 0:begin
                   //RGB
                   pBit[iCounter]  :=Table[pBit[iCounter]];
                   pBit[iCounter+1]:=Table[pBit[iCounter+1]];
                   pBit[iCounter+2]:=Table[pBit[iCounter+2]];
                   end;
                 1:begin
                   //R
                   pBit[iCounter]:=Table[pBit[iCounter]];
                   end;
                 2:begin
                   //G
                   pBit[iCounter+1]:=Table[pBit[iCounter+1]];
                   end;
                 3:begin
                   //B
                   pBit[iCounter+2]:=Table[pBit[iCounter+2]];
                   end;
            end;
            inc(iCounter,4);
          end;
       end;
    end;   
begin

  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Postlarization32(BMP,iCh,iPower);
       pf24bit:Postlarization24(BMP,iCh,iPower);
       else begin
        Result:=False;
       end;
  end;

end;

/////////////////////////////////////////////////////////
//
//   `l@
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.ChannelExchange(BMP:TBitmap;iIn,iOut:Byte;bNot,bTrade:Boolean):Boolean;

    procedure ChannelExchangeData(var r,g,b,a:Byte;iIn,iOut:Byte);

       function GetData:Byte;
       begin
         Result:=0;

         case iIn of
              0:Result:=r;
              1:Result:=g;
              2:Result:=b;
              3:Result:=a;
         end;

         if bNot then Result:=not Result;

       end;

       function TradeData(iData:Byte):Byte;
       begin

         if bNot then iData:=not iData;


         case iIn of
              0:begin
                 Result:=r;
                 r:=iData;
                end;
              1:begin
                 Result:=g;
                 g:=iData;
                end; 
              2:begin
                 Result:=b;
                 b:=iData;
                end;
              3:begin
                 Result:=a;
                 a:=iData;
                end;
         end;

         if bNot then Result:=not Result;

       end;

    begin
       { 0:r
         1:g
         2:b
         3:a
       }

       if not bTrade then begin
          case iOut of
               0:r:=GetData;
               1:g:=GetData;
               2:b:=GetData;
               3:a:=GetData;
          end;
       end else begin
          case iOut of
               0:r:=TradeData(r);
               1:g:=TradeData(g);
               2:b:=TradeData(b);
               3:a:=TradeData(a);
          end;
       end;
    end;


    procedure ChEx32(Bitmap: TBitmap);
    var
      X, Y,w: Integer;
      pLine: PByteArray;
      iCounter:Integer;
      r,g,b,a :Byte;
    begin

      w:=Bitmap.Width -1;

      { sNZ̕ϊ }
      for Y := 0 to Bitmap.Height -1 do begin
        pLine := Bitmap.ScanLine[Y];
        
        //JE^[
        iCounter:=0;
        
        for X := 0 to w do begin

            r:=pLine[iCounter];
            g:=pLine[iCounter+1];
            b:=pLine[iCounter+2];
            a:=pLine[iCounter+3];

            ChannelExchangeData(r,g,b,a,iIn,iOut);

            pLine[iCounter]:=r;
            pLine[iCounter+1]:=g;
            pLine[iCounter+2]:=b;
            pLine[iCounter+3]:=a;


            inc(iCounter,4);
        end;
        //R[obN
        if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
    end;
    
    procedure ChEx24(Bitmap: TBitmap);
    // \[[V
    var
      X, Y,w: Integer;
      pLine: PByteArray;
      iCounter:Integer;
      r,g,b,a :Byte;
    begin

      w:=Bitmap.Width -1;

      { sNZ̕ϊ }
      for Y := 0 to Bitmap.Height -1 do begin
        pLine := Bitmap.ScanLine[Y];
        
        //JE^[
        iCounter:=0;
        a:=0;
        
        for X := 0 to w do begin
            r:=pLine[iCounter];
            g:=pLine[iCounter+1];
            b:=pLine[iCounter+2];

            ChannelExchangeData(r,g,b,a,iIn,iOut);

            pLine[iCounter]:=r;
            pLine[iCounter+1]:=g;
            pLine[iCounter+2]:=b;

            inc(iCounter,3);
        end;
        //R[obN
        if @OnProgress<>nil then OnProgress(y,BMP.Height);
      end;
    end;
begin

  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:ChEx32(BMP);
       pf24bit:ChEx24(BMP);
       else begin
        Result:=False;
       end;
  end;

end;

//***************************************************************************************
/////////////////////////////////////////////////////////
//
//   ㉺]
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.RotateTopBottom(BMP:TBitmap):Boolean;
var BMP2:TBitmap;
    y:Integer;
begin

  BMP2:=TBitmap.Create;
  try
    BMP2.Assign(BMP);

    for y:=0 to BMP.Height-1 do begin
      Result:=BitBlt(BMP.Canvas.Handle,0,BMP.Height-y-1,BMP.Width,1,BMP2.Canvas.Handle,0,y,SRCCOPY);
    end;

  finally
    BMP2.Free;
  end;

end;

/////////////////////////////////////////////////////////
//
//   E]
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.RotateMirror(BMP:TBitmap):Boolean;
var BMP2:TBitmap;
    x:Integer;
begin

  BMP2:=TBitmap.Create;
  try
    BMP2.Assign(BMP);

    for x:=0 to BMP.Width-1 do begin
      Result:=BitBlt(BMP.Canvas.Handle,BMP.Width-x-1,0,1,BMP.Height,BMP2.Canvas.Handle,x,0,SRCCOPY);
    end;
  finally
    BMP2.Free;
  end;

end;

//***************************************************************************************
/////////////////////////////////////////////////////////
//
//   E܂90
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Rotate90Right(BMP:TBitmap):Boolean;

  procedure Rotate32(BMP:TBitmap);
  var BMP2:TBitmap;
      pBit:PRGBAArray;
      rgba:TRGBA;
      x,y:Integer;
  begin

      BMP2:=TBitmap.Create;
      try
       //m
       BMP2.PixelFormat:=pf32bit;
       BMP2.Width :=BMP.Height;
       BMP2.Height:=BMP.Width;

       //ւvZ
       for y:=0 to BMP.Height-1 do begin
           pBit:=BMP.Scanline[BMP.Height-y-1];
           for x:=0 to BMP.Width-1 do begin
               PRGBAArray(BMP2.ScanLine[x])[y]:=pBit[x];
           end;
       
           //R[obN
           if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;

      finally
       BMP.Assign(BMP2);
       BMP2.Free;
      end;

  end;

  procedure Rotate24(BMP:TBitmap);
  var BMP2:TBitmap;
      pBit:PRGBArray;
      rgb:TRGB;
      x,y:Integer;
  begin

      BMP2:=TBitmap.Create;
      try
       //m
       BMP2.PixelFormat:=pf24bit;
       BMP2.Width :=BMP.Height;
       BMP2.Height:=BMP.Width;

       //ւvZ
       for y:=0 to BMP.Height-1 do begin
           pBit:=BMP.Scanline[BMP.Height-y-1];
           for x:=0 to BMP.Width-1 do begin
               PRGBArray(BMP2.ScanLine[x])[y]:=pBit[x];
           end;
       
           //R[obN
           if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;

      finally
       BMP.Assign(BMP2);
       BMP2.Free;
      end;

  end;
    

begin

  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Rotate32(BMP);
       pf24bit:Rotate24(BMP);
       else begin
        Result:=False;
       end;
  end;

end;

/////////////////////////////////////////////////////////
//
//   ܂90
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Rotate90Left(BMP:TBitmap):Boolean;

  procedure Rotate32(BMP:TBitmap);
  var BMP2:TBitmap;
      pBit:PRGBAArray;
      rgba:TRGBA;
      x,y:Integer;
  begin

      BMP2:=TBitmap.Create;
      try
       //m
       BMP2.PixelFormat:=pf32bit;
       BMP2.Width :=BMP.Height;
       BMP2.Height:=BMP.Width;

       //ւvZ
       for y:=0 to BMP.Height-1 do begin
           pBit:=BMP.Scanline[y];
           for x:=0 to BMP.Width-1 do begin
               PRGBAArray(BMP2.ScanLine[x])[y]:=pBit[x];
           end;
       
           //R[obN
           if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;

      finally
       BMP.Assign(BMP2);
       BMP2.Free;
      end;

  end;

  procedure Rotate24(BMP:TBitmap);
  var BMP2:TBitmap;
      pBit:PRGBArray;
      rgb:TRGB;
      x,y:Integer;
  begin

      BMP2:=TBitmap.Create;
      try
       //m
       BMP2.PixelFormat:=pf24bit;
       BMP2.Width :=BMP.Height;
       BMP2.Height:=BMP.Width;

       //ւvZ
       for y:=0 to BMP.Height-1 do begin
           pBit:=BMP.Scanline[y];
           for x:=0 to BMP.Width-1 do begin
               PRGBArray(BMP2.ScanLine[BMP.Width-x-1])[y]:=pBit[x];
           end;
       
           //R[obN
           if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;

      finally
       BMP.Assign(BMP2);
       BMP2.Free;
      end;

  end;
    

begin

  //
  Result:=True;

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Rotate32(BMP);
       pf24bit:Rotate24(BMP);
       else begin
        Result:=False;
       end;
  end;

end;

/////////////////////////////////////////////////////////
//
//   AtBϊ
//
/////////////////////////////////////////////////////////

function TBuinPicFilters.Affine(a,b,c,d,e,f:Integer;BMP,NewBMP:TBitmap):Boolean;
var
  x,y:Integer;
  u,v:Integer;

  //AD-BC
  adbc,bfed,afce:Integer;
  //p
  table:array of Pointer;
  //vZ[vO
  lopU,lopV:Integer;
  //Z̑pvZ
  dx,dy:Integer;

    procedure Affine32;
    var pBitIn,pBitOut:PRGBAArray;
        data:TRGBA;
        y,x:Integer;
    begin
       //LbVe[u
       SetLength(Table,BMP.Height);
       for y:=0 to BMP.Height-1 do begin
           table[y]:=BMP.ScanLine[y];
       end;
       //   
       for y:=0 to BMP.Height-1 do begin
           pBitOut :=NewBMP.Scanline[y];
           //[vOŌvZ
           lopU:=(-b*y+bfed);
           lopV:=(a*y+afce);
           //ZȂ悤
           dx:=-d;
           dy:=c;

           for x:=0 to BMP.Width-1 do begin
               //̕ϊ
               inc(dx,d);
               dec(dy,c);
               {U}
               u:=(dx+lopU) div adbc;
               if (u<0) or (u>=BMP.Width) then Continue;
               {V}
               v:=(dy+lopV) div adbc;
               if (v<0) or (v>=BMP.Height) then Continue;
               //ǂݎ
               pBitIn:=table[v];
               pBitOut[x]:=pBitIn[u];
           end;
           //R[obN
           if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;
    end;

    procedure Affine24;
    var pBitIn,pBitOut:PRGBArray;
        data:TRGB;
        y,x:Integer;
    begin
       //LbVe[u
       SetLength(Table,BMP.Height);
       for y:=0 to BMP.Height-1 do begin
           table[y]:=BMP.ScanLine[y];
       end;
       //   
       for y:=0 to BMP.Height-1 do begin
           pBitOut :=NewBMP.Scanline[y];
           //[vOŌvZ
           lopU:=(-b*y+bfed);
           lopV:=(a*y+afce);
           //ZȂ悤
           dx:=-d;
           dy:=c;

           for x:=0 to BMP.Width-1 do begin
               //̕ϊ
               inc(dx,d);
               dec(dy,c);
               {U}
               u:=(dx+lopU) div adbc;
               if (u<0) or (u>=BMP.Width) then Continue;
               {V}
               v:=(dy+lopV) div adbc;
               if (v<0) or (v>=BMP.Height) then Continue;
               //ǂݎ
               pBitIn:=table[v];
               pBitOut[x]:=pBitIn[u];
           end;
           //R[obN
           if @OnProgress<>nil then OnProgress(y,BMP.Height);
       end;
    end;

begin

  //
  Result:=True;

   adbc:=(a*d-b*c) div 255;
   bfed:=(b*f-e*d);
   afce:=(c*e-a*f);

  //ۂ̏
  case BMP.PixelFormat of
       pf32bit:Affine32;
       pf24bit:Affine24;
       else begin
        Result:=False;
       end;
  end;

end;

//***************************************************************************************
//    
//    
//    NXŎgp֐
//    
//    
//***************************************************************************************

function RoundByte(data:Integer):Byte;
begin
  if Data>255 then Data:=255
  else if Data< 0 then Data:=0;
  Result:=Data;
end;

end.
